import com.ms.dll.*;
import com.ms.win32.*;

public class ShowCallback
{
    public static void main(String args[]) throws InterruptedException
    {
        boolean ok = User32.EnumWindows(new EnumWindowsProc(), 0);

        if (!ok)
            System.err.println("EnumWindows failed.");
	
		Thread.currentThread().sleep(3000);
    }
}

class EnumWindowsProc extends Callback
{
    public boolean callback(int hwnd, int lparam)
    {
        StringBuffer text = new StringBuffer(50);
        User32.GetWindowText(hwnd, text, text.capacity()+1);

        if (text.length() != 0)
            System.out.println(text);

        return true;  // to continue enumeration.
    }

}

