#include <windows.h>
#include <stdio.h>
#include "CreateObjects.h"

BOOL APIENTRY DllMain (HANDLE hModule, DWORD dwReason, void** lpReserved)
{
	return TRUE;
}

JNIEXPORT jobject JNICALL Java_CreateObjects_getNewObject
  (JNIEnv * env, jobject jThis)
{
	// Gets the class object
	jclass cls = env->FindClass("MyJavaClass");

	// Checks for exceptions (apparently, never thrown)
	jthrowable exc = env->ExceptionOccurred();
	if (exc != NULL)
	{
		env->ExceptionDescribe();
		env->ExceptionClear();
	}

	// Re-checks for errors
	if ( !cls )
		printf("Class not found!\n");

	// Gets ctor method id
	jmethodID ctorID = env->GetMethodID(cls, "DivByTwo", "(I)");

	jobject obj = env->NewObject(cls, ctorID, 3);

	return obj;
}

