class IsZeroException extends Exception {}

class MyJavaClass
{
	public void divByTwo() throws IsZeroException
	{
		if (aValue == 0)
			throw new IsZeroException();

		aValue /= 2;
	}

	public int aValue;
}

public class JNIExc 
{
	public static void main(String [] args)
	{
		JNIExc app = new JNIExc();

		MyJavaClass anObj = new MyJavaClass();
		anObj.aValue = 2;
		app.changeObject(anObj);
		System.out.println("Java  : " + anObj.aValue);
	}

	private native void changeObject(MyJavaClass obj);

	static 
	{
		System.loadLibrary("UseObjImpl");
	}
}

