#include <windows.h>
#include <stdio.h>
#include "UseObjects.h"

BOOL APIENTRY DllMain (HANDLE hModule, DWORD dwReason, void** lpReserved)
{
	return TRUE;
}

JNIEXPORT void JNICALL Java_JNIExc_changeObject
  (JNIEnv * env, jobject this, jobject obj)
{
	jclass cls;
	jfieldID fid;
	jmethodID mid;
	int value;
	jthrowable exc;

	cls = (*env)->GetObjectClass(env, obj);
	fid = (*env)->GetFieldID(env, cls, "aValue", "I");
	mid = (*env)->GetMethodID(env, cls, "divByTwo", "()V");

	value = (*env)->GetIntField(env, obj, fid);
	printf("Native: %d\n", value);

	(*env)->SetIntField(env, obj, fid, 6);
	(*env)->CallVoidMethod(env, obj, mid);

	value = (*env)->GetIntField(env, obj, fid);
	printf("Native: %d\n", value);

	(*env)->SetIntField(env, obj, fid, 0);
	(*env)->CallVoidMethod(env, obj, mid);

	exc = (*env)->ExceptionOccurred(env);
	if (exc != NULL)
	{
		(*env)->ExceptionDescribe(env);
		(*env)->ExceptionClear(env);
	}

	value = (*env)->GetIntField(env, obj, fid);
	printf("Native: %d\n", value);
}

