#include <windows.h>
#include <stdio.h>
#include "UseObjects.h"

BOOL APIENTRY DllMain (HANDLE hModule, DWORD dwReason, void** lpReserved)
{
	return TRUE;
}

JNIEXPORT void JNICALL Java_UseObjects_changeObject
  (JNIEnv * env, jobject jThis, jobject obj)
{
	jclass cls;
	jfieldID fid;
	jmethodID mid;
	int value;

	cls = env->GetObjectClass(obj);
	fid = env->GetFieldID(cls, "aValue", "I");
	mid = env->GetMethodID(cls, "divByTwo", "()V");

	value = env->GetIntField(obj, fid);
	printf("Native: %d\n", value);

	env->SetIntField(obj, fid, 6);
	env->CallVoidMethod(obj, mid);

	value = env->GetIntField(obj, fid);
	printf("Native: %d\n", value);
}

